---
title: llarp/net/net_if.hpp

---

# llarp/net/net_if.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::net](Namespaces/namespacellarp_1_1net.md)** <br>get a sock addr we can use for all interfaces given our public address  |




## Source code

```cpp
#pragma once
#ifndef _WIN32
// this file is a shim include for #include <net/if.h>
#if defined(__linux__)
#include <linux/if.h>
extern "C" unsigned int
#ifndef __GLIBC__
if_nametoindex(const char* __ifname);
#else
if_nametoindex(const char* __ifname) __THROW;
#endif
#else
#include <net/if.h>
#endif
#endif

namespace llarp::net
{
  std::string
  LoopbackInterfaceName();
}  // namespace llarp::net
```


-------------------------------

Updated on 2022-07-31 at 00:14:32 +0000
