---
title: llarp/constants/platform.hpp

---

# llarp/constants/platform.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::platform](Namespaces/namespacellarp_1_1platform.md)** <br>namespace for platform feature detection constexprs  |




## Source code

```cpp
#pragma once

namespace llarp::platform
{
  inline constexpr bool is_linux =
#ifdef __linux__
      true
#else
      false
#endif
      ;

  inline constexpr bool is_freebsd =
#ifdef __FreeBSD__
      true
#else
      false
#endif
      ;

  inline constexpr bool is_windows =
#ifdef _WIN32
      true
#else
      false
#endif
      ;

  inline constexpr bool is_apple =
#ifdef __apple__
      true
#else
      false
#endif
      ;

  inline constexpr bool is_android =
#ifdef ANDROID
      true
#else
      false
#endif
      ;

  inline constexpr bool is_iphone =
#ifdef IOS
      true
#else
      false
#endif
      ;

  inline constexpr bool is_mobile = is_android or is_iphone;

  inline constexpr bool supports_ipv6 = not is_windows;
}  // namespace llarp::platform
```


-------------------------------

Updated on 2022-07-31 at 00:14:32 +0000
